// HU.h      2002.5.21

#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <time.h>
#include <math.h> 

#define Main				mainHU
#define TextWindow			TextWindowSizeHU
#define GraphicWindow		CreateGraphicWindowHU
#define SetColor			SetColorHU
#define PenWidth			SetPenWidthHU
#define Line				LineHU
#define Rect				RectHU
#define Dot					DotHU
#define Circle				CircleHU
#define SetPixel			SetPixelHU
#define ClearWindow			ClearWindowHU
#define FontSize			FontSizeHU
#define ChangeFont			ChangeFontHU
#define GetFileName			GetFileNameHU
#define DrawTextWindow		DrawTextWindowHU
#define DrawString			DrawStringHU
#define _ChangeFontSize		_ChangeFontSizeHU
#define Event				EventHU
#define ResizeTextWindow	ResizeTextWindowHU
#define _SaveTextBuffer		_SaveTextBufferHU
#define Title				TitleHU
#define Msg					MsgHU
#define GetMouse			GetMouseHU
#define Flush				FlushHU
#define CreateButton		CreateButtonHU
#define SetButtonFunc		SetButtonFuncHU
#define _DrawScanfBuffer	_DrawScanfBufferHU
#define SaveGraphicWindow	SaveGraphicWindowHU
#define printf				printfHU
#define scanf				scanfHU

#define APP_WIN_CLASS		"Application"
#define APP_GRA_CLASS		"Graphics"
#define DEFAULT_CAPTION		"Win32 Application"
#define DEFAULT_GRA_CAP		"Images"
#define _DEF_GRA_FONT_TYPE	"SVbN"
#define _DEF_TEXT_STEP_RATE	1.0		
#define _DEFAULT_TEXT_X		480		
#define _DEFAULT_TEXT_Y		480		
#define _DEFAULT_FONT_SIZE	15		
#define _DEF_GRA_FONT_SIZE	10		
#define _MAX_TEXT_LINE		200		
#define _MAX_ONE_LINE		160		
#define _MAX_ARGS			31
#define _TIMER_PER_WAIT		500		
#define _BUTTON_NUMBER_MAX	20		
#define _MAX_SCANF_BUFF		512		

#define INITGx 100					
#define INITGy 20					

#define IDM_FONT_TINY		1		
#define IDM_FONT_SMALL		2		
#define IDM_FONT_DEFAULT	3		
#define IDM_FONT_LARGE		4		
#define IDM_FONT_HUGE		5		
#define IDM_TEXT_SAVE		6
#define IDM_GRAPH_SAVE		7
#define IDM_EXIT			8

#define	BK_BLACK			0		
#define	BK_GRAY				1
#define	BK_WHITE			2		

#define BLACK			RGB(   0,   0,   0 )
#define RED				RGB( 255,   0,   0 )
#define GREEN			RGB(   0, 255,   0 )
#define BLUE			RGB(   0,   0, 255 )
#define PURPLE			RGB( 255,   0, 255 )
#define SKYBLUE			RGB(   0, 255, 255 )
#define YELLOW			RGB( 255, 255,   0 )
#define WHITE			RGB( 255, 255, 255 )

#define L_RED			RGB( 128,   0,   0 )
#define L_GREEN			RGB(   0, 128,   0 )
#define L_BLUE			RGB(   0,   0, 128 )
#define L_PURPLE		RGB( 128,   0, 128 )
#define L_SKYBLUE		RGB(   0, 128, 128 )
#define L_YELLOW		RGB( 128, 128,   0 )
#define L_WHITE			RGB( 128, 128, 128 )


HWND	hMWnd;						
HWND	hGWnd;						
HWND	hMenu;						
HWND	_hButton[_BUTTON_NUMBER_MAX];
HDC		hMemDC = 0;					
HBITMAP	hBitmap = 0;
HFONT	_hFont, _hGFont;
PLOGFONT _MFontInfo,_GFontInfo;		
RECT	_InRect;
COLORREF _PenColor;					
int		_PenWidth = 1;				
int		_GraphBkColor;				
int		_TimerID;					
WNDPROC	fnMainProc;
HINSTANCE _ghInstance;

int		_ButtonNumber = 0;			
int		_FontSizeY;					
char	_TextBuff[_MAX_TEXT_LINE][_MAX_ONE_LINE+1];
int		_LastYPos;					
int		_WinTopPos;					
int		_WinHeight;					
int		_CuBuffPos;					
int		_CuBuffTopPos;				
int		_CuBuffHeight;				
int		_RelativePos;				

char	_scanfFormat[256];			
LPVOID	_lpscanfPtr[256];				
int		_GWinSizeX, _GWinSizeY;		
POINT	_MousePosL, _MousePosR;		

BOOL	_IsEditActive;				
BOOL	_IsSBuffDarw;				
BOOL	_IsCaretVisible = FALSE;	
BOOL	_IsLastPosVisible = TRUE;	
BOOL	_IsPrintfChange = FALSE;
BOOL	_IsGraphChange  = FALSE;
BOOL	_IsGraphShow    = FALSE;
BOOL	_IsLButtonDown	= FALSE;
BOOL	_IsRButtonDown	= FALSE;
char	_FontFaceName[32] = "lr SVbN";

char	_ScanfBuff[_MAX_SCANF_BUFF];
int		_ScanfBuffLen = 0;			

int printfHU( const char *format,... ); 
int scanfHU( const char *format,... );  

void GetDVhdr(FILE *fp,int ii,long *OFFSET,int *MAXSLICE,int *MAXFRAME,double *CoFac,double *Pi_X,double *Pi_Y,double *Res_Z);
void Set_scale(int CLmode, int *R, int *G, int *B, double max, char *caption, char *unit);

void DrawStringHU( int x, int y, char *s );
void SetColorHU( COLORREF col );
void SetBkModeHU( int BkMode );
void DrawNumInt(int x, int y, int num,int sep); 
void DrawNumDouble(int x, int y, double num,int ika, int sep); 
void SetPenWidthHU( int Width );
void MoveToHU( int x, int y);
void LineToHU( int x, int y);
void LineHU( int x1, int y1, int x2, int y2 );
void RectHU( int x1, int y1, int x2, int y2, int mode );
void DotHU( int cx, int cy, int r );
void CircleHU( int cx, int cy, int r );
void SetPixelHU( int x, int y );
void ClearWindowHU( void );
void ShowWindowHU( int mode );
void CreateGraphicWindowHU( int width, int height, int bk );
void FontSizeHU( int size );
void ChangeFontHU( char *Type, int Size, int Round, int Bold, int Italic, int Line);
void GetFileNameHU( char *s, int mode );
void TextWindowSizeHU( int ix, int iy, int width, int height );
void _scanfHU_2( void );
void DrawTextWindowHU( void );
void _ChangeFontSizeHU( int size );
void EventHU( void );
void ResizeTextWindowHU( void );
void _SaveTextBufferHU( void );
void TitleHU( const char *s );
void MsgHU( const char *format,... );
void GetMouseHU( int *x, int *y, int *button );
void FlushHU( void );
void CreateButtonHU( int Index, char *s, int x, int y, int width, int height );
void SetButtonFuncHU( void (*f)(int) );
void _DrawScanfBufferHU( void );
void SaveGraphicWindowHU( char *FileName );
BOOL  _InitAppHU( HINSTANCE hThisInstance, int nCmdShow );
LRESULT CALLBACK WndFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndGraFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
void CALLBACK _TimerRTFProc( HWND hWnd, UINT uTMsg, UINT uTID, DWORD dwTime );
LRESULT CALLBACK EditFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

void (*ButtonFuncNameHU)( int Index ); 
void mainHU( void );

	
void GetDVhdr(FILE *fp,int ii,long *OFFSET,int *MAXSLICE,int *MAXFRAME,double *CoFac,double *Pi_X,double *Pi_Y,double *Res_Z)
{
	#define BUF4 (buf[0]*256+buf[1])*65536+buf[2]*256+buf[3]
	
	char f[65],bch[64];			// f[]:̧ق߽+̧ٖ,ft[]:̧ٖ
								// bch[]:ͯް̧ق̓̕Ǎݗpޯ̧
								// buf[]:ͯް̧ق̐lǍݗpޯ̧
	int i,buf[64],g1,g2,w1,w2,by1,by2,by3,by4,dat,ch,ch2;
								// g1,g2:ͯް̧ق̕ϐ̑Group(ʉ)
								// w1,w2:ͯް̧ق̕ϐElementԍ(ʉ)
								// by1--by4:ϐ(Byte)Ǎp.ŏʂby1
								// ch,ch2:16i10iɕϊۂؕϐ

	long scdata, GR, EL, GREL, byt;
					// OFFSET:Ұް̈ʒu\(ِ̧擪牽޲Ėڂj
					// s0:ڰт̂ײ̐擪\(ِ̧擪牽޲Ėڂj
					// s :ڰт̂ײ̂߸ق\(ِ̧擪牽޲Ėڂj
					// scdata:ͯް̧قǂގɓǂވʒu(޲ĐjD
					// GR, EL, GREL: GroupԍCElementԍCGroup-Elementԍ
					// byt:ͯް̧ق̕ǂނƂ̕޲Đ

	for(i=0;i<64;i++){bch[i]=' ';buf[i]=0;}
	scdata=0L;*CoFac=*Res_Z=*Pi_X=*Pi_Y=0.0;
	
	GR=EL=GREL=0; // GREL: Group and Element @ &h0028 &h0010 -> 280010 (10i)

	//ͯް̧ق̓Ǎ݂Ǝvϐ̊i[

	while(GR!=8640){  // Group&h7FE0ɂȂI (7*10+15)*100+14*10+0=8640
		fseek(fp,scdata,SEEK_SET);g1=fgetc(fp);   // g1,g2: Group
		fseek(fp,scdata+1,SEEK_SET);g2=fgetc(fp);
		fseek(fp,scdata+2,SEEK_SET);w1=fgetc(fp); // w1,w2: Element
		fseek(fp,scdata+3,SEEK_SET);w2=fgetc(fp);
		if(g1>=16){ch=g1/16;ch2=g1-ch*16;g1=ch*10+ch2;} // 16i->10i
		if(g2>=16){ch=g2/16;ch2=g2-ch*16;g2=ch*10+ch2;}
		if(w1>=16){ch=w1/16;ch2=w1-ch*16;w1=ch*10+ch2;}
		if(w2>=16){ch=w2/16;ch2=w2-ch*16;w2=ch*10+ch2;}
		GR=g1*100+g2;EL=w1*100+w2;GREL=GR*10000+EL;
		fseek(fp,scdata+4,SEEK_SET);by1=fgetc(fp);		//byt:oCg
		fseek(fp,scdata+5,SEEK_SET);by2=fgetc(fp);
		fseek(fp,scdata+6,SEEK_SET);by3=fgetc(fp);
		fseek(fp,scdata+7,SEEK_SET);by4=fgetc(fp);
		byt=(by1*256+by2)*65536+by3*256+by4;
		scdata+=8;			// GroupElement޲Đ8byte͂ǂ̍ڂłl
		if(byt<=4)for(i=0;i<=(byt-1);i++)
			{fseek(fp,scdata+i,SEEK_SET);dat=fgetc(fp);if(i<64)buf[i]=dat;}
		else {
			for(i=0;i<=(byt-1);i++)
				{fseek(fp,scdata+i,SEEK_SET);dat=fgetc(fp);if(i<64)bch[i]=dat;}
			if(byt<64){bch[byt]=' ';}
			}
		//lbuf[]ցCƎv4޲Ă𒴂̂bch[]Ɋi[D
		//yٍ̧\z
		// : 3.568245173  33 2E 35 36 38 32 34 35 31 37 33 ƂȂĂ
		// ĕzɊi[Catof֐pĐlɂD
		// atof3.568245e-06Ƃw^ɂΉĂD
		// ܂Cľɋ؂ĂȂƕϊlςɂȂ̂Ž߰}D

        if(ii)printf("\n%ld %s",GREL,bch);
		
		scdata+=byt;
		switch(GREL){		//Ǎ񂾕ϐGroopElementɉs

		
			case 90100:	 *OFFSET=BUF4;break;
			case 210100: *MAXSLICE=BUF4;break;
			case 210110: *MAXFRAME=BUF4;break;
			case 280030: bch[(byt-1)/2]=' ';*Pi_X=atof(bch);
						 *Pi_Y=atof(bch+(byt-1)/2+1);break;
				//280030̍ڂɂ́C2̐li[ĂDႦ21޲Ăł΁C
				//n߂10޲Ăx̒lŁC1\}[Nc10޲Ăy̒lƂȂD

			case 290100: *Res_Z=atof(bch);break;
			case 290120: *CoFac=atof(bch);break;
			
			case 100010: strcpy(f,bch);	
			
			default: ;
			}
	}

	// vȕϐ̒l̕\
	printf("\n OFFSET: %ld\n slice : %d\n frame : %d\n",*OFFSET,*MAXSLICE,*MAXFRAME);
	printf(" const. fac.: %.6le\n pixel x(mm): %lf\n",*CoFac,*Pi_X);
	printf(" pixel y(mm): %lf\n res. z(mm) : %lf\n",*Pi_Y,*Res_Z);
	printf(" name = %s\n",f);
	return;
}

	

void Set_scale(int CLmode, int *R, int *G, int *B, double max, char *caption, char *unit)
{
	char	bufc[10],f[30];
	int		i,j,bw,iMMR,sint;
	double	xm;
	
	for(i=0;i<256;i++){	bw = i;
		if(CLmode==1){bw=255-bw;SetColorHU(RGB(bw,bw,bw));}
		if(CLmode==2)SetColorHU(RGB(bw,bw,bw));
		if(CLmode==3)SetColorHU(RGB(R[bw],G[bw],B[bw]));
		for(j=0;j<=20;j++){ SetPixelHU(23+j,600-i*2); SetPixelHU(23+j,600-i*2-1);}
	}

	xm=256.0/max;
	
	SetColorHU(RGB(255,255,255));
	
	ChangeFontHU("Times New Roman",24,0,1,0,0);	DrawStringHU(8,20,caption);

	ChangeFontHU("System",8,0,0,0,0);DrawStringHU(10,50,unit);

	ChangeFontHU("System",18,0,1,0,0);

	for(i=-8;i<8;i++){if(max<pow(10.,(double)(i))){sint=(int)pow(10.,(double)(i-1));break;}}
	for(iMMR=0;iMMR<=(int)max;iMMR+=sint){
		
		if( (int)((double)(iMMR)*xm) > 256 )break;
		for(j=0;j<=10;j++){SetPixelHU(40+j,600-(int)((double)(iMMR)*xm)*2);} 
		_itoa(iMMR,bufc,10);if(iMMR<10){strcpy(f," ");strcat(f,bufc);strcpy(bufc,f);}
		DrawStringHU(55,600-(int)((double)(iMMR)*xm)*2-7,bufc);
	}
}

void DrawStringHU( int x, int y, char *s )
{
	HFONT hOF;

	_hGFont = CreateFontIndirect( _GFontInfo );
	hOF = SelectObject( hMemDC, _hGFont );
	SetTextColor( hMemDC, _PenColor ); // p.622
	TextOut( hMemDC, x, y, s, strlen( s ) );
	SelectObject( hMemDC, hOF );
	DeleteObject( hOF );
	DeleteObject( _hGFont ); _hGFont = 0;
	_IsGraphChange = TRUE;
}

void SetColorHU( COLORREF col )
{
	_PenColor = col;
}

void DrawNumInt(int x,int y,int num, int sep)
{
	int ti,tm1,tm2,tmm;
	tmm=tm1=(int)(log10((double)num));  
	if(num<0){DrawStringHU(x,y,"-");x=x+sep;num=-num;}
	for(ti=0;ti<=tmm;ti++){
		tm2=(int)(num/pow(10.0,(double)tm1));
		switch(tm2){
			case 0: DrawStringHU(x,y,"0");break;
			case 1: DrawStringHU(x,y,"1");break;
			case 2: DrawStringHU(x,y,"2");break;
			case 3: DrawStringHU(x,y,"3");break;
			case 4: DrawStringHU(x,y,"4");break;
			case 5: DrawStringHU(x,y,"5");break;
			case 6: DrawStringHU(x,y,"6");break;
			case 7: DrawStringHU(x,y,"7");break;
			case 8: DrawStringHU(x,y,"8");break;
			case 9: DrawStringHU(x,y,"9");break;
			}
		num=num-(int)(tm2*pow(10.0,(double)tm1));
		x=x+sep;tm1--;
		}
}

void DrawNumDouble(int x, int y, double num,int ika,int sep)
{
	int ti,tm1,tm2,tmm;
	if(num<0.0){DrawStringHU(x,y,"-");x=x+sep;num=-num;}
	num*=pow(10.0,(double)ika);
	tmm=tm1=(int)(log10((double)num));  	if(tmm==0)tmm=tm1=1;
	for(ti=0;ti<=tmm;ti++){
		tm2=(int)(num/pow(10.0,(double)tm1));
		switch(tm2){
			case 0: DrawStringHU(x,y,"0");break;
			case 1: DrawStringHU(x,y,"1");break;
			case 2: DrawStringHU(x,y,"2");break;
			case 3: DrawStringHU(x,y,"3");break;
			case 4: DrawStringHU(x,y,"4");break;
			case 5: DrawStringHU(x,y,"5");break;
			case 6: DrawStringHU(x,y,"6");break;
			case 7: DrawStringHU(x,y,"7");break;
			case 8: DrawStringHU(x,y,"8");break;
			case 9: DrawStringHU(x,y,"9");break;
			}
		num=num-(int)(tm2*pow(10.0,(double)tm1));
		x=x+sep;
		if(ti==tmm-ika)
			{x=x-(int)(sep*0.2);DrawStringHU(x,y,".");x=x+(int)(sep*0.7);}
		tm1--;
		}
}

void SetBkModeHU( int BkMode )
{
	switch(BkMode){
		case 1:SetBkMode( hMemDC,TRANSPARENT);break; 
		default:SetBkMode( hMemDC,OPAQUE );
	}
}

void SetPenWidthHU( int Width )
{
	_PenWidth = Width;
}
void MoveToHU( int x, int y )
{
	MoveToEx( hMemDC, x, y, NULL );
}
void LineToHU( int x, int y )
{
	HPEN hPen,hOldPen;
	hPen = CreatePen( PS_SOLID, _PenWidth, _PenColor );
	hOldPen = SelectObject( hMemDC, hPen );
	LineTo( hMemDC, x,y );
	SelectObject( hMemDC, hOldPen );
	DeleteObject( hPen );
	_IsGraphChange = TRUE;
}
void LineHU( int x1, int y1, int x2, int y2 )
{
	POINT pp;
	HPEN hPen,hOldPen;
	hPen = CreatePen( PS_SOLID, _PenWidth, _PenColor );
	hOldPen = SelectObject( hMemDC, hPen );
	MoveToEx( hMemDC, x1,y1,&pp ); LineTo( hMemDC, x2,y2 );
	SetPixelV( hMemDC, x2, y2, _PenColor );
	MoveToEx( hMemDC, pp.x,pp.y, NULL );
	SelectObject( hMemDC, hOldPen );
	DeleteObject( hPen );
	_IsGraphChange = TRUE;
}
void RectHU( int x1, int y1, int x2, int y2, int mode )
{
	POINT pp;
	HPEN hPen,hOldPen;
	HBRUSH hB,hOB;

	hPen = CreatePen( PS_SOLID, _PenWidth, _PenColor );
	hB = CreateSolidBrush( _PenColor );
	hOldPen = SelectObject( hMemDC, hPen );
	hOB= SelectObject( hMemDC, hB );

	if( mode==0 ){ 
		MoveToEx( hMemDC, x1,y1,&pp ); LineTo( hMemDC, x2,y1 );
		LineTo( hMemDC, x2,y2 ); LineTo( hMemDC, x1,y2 );
		LineTo( hMemDC, x1,y1 ); MoveToEx( hMemDC, pp.x,pp.y, NULL );
	}else{ 
		Rectangle( hMemDC, x1,y1,x2,y2 );
	}
	SelectObject( hMemDC, hOldPen );
	SelectObject( hMemDC, hOB );
	DeleteObject( hPen );
	DeleteObject( hB );
	_IsGraphChange = TRUE;
}
void DotHU( int cx, int cy, int r )
{
	HPEN hPen,hOldPen;
	HBRUSH hB,hOB;

	hPen = CreatePen( PS_SOLID, _PenWidth, _PenColor );
	hB = CreateSolidBrush( _PenColor );
	hOldPen = SelectObject( hMemDC, hPen );
	hOB= SelectObject( hMemDC, hB );

	Ellipse(hMemDC, cx-r, cy-r, cx+r, cy+r); // p.663
	SelectObject( hMemDC, hOldPen );
	SelectObject( hMemDC, hOB );
	DeleteObject( hPen );
	DeleteObject( hB );
	_IsGraphChange = TRUE;
}
void CircleHU(int cx, int cy, int r )
{
	HPEN hPen,hOldPen;

	hPen = CreatePen( PS_SOLID, _PenWidth, _PenColor );
	hOldPen = SelectObject( hMemDC, hPen );
	Arc( hMemDC, cx-r,cy-r,cx+r,cy+r, cx,cy-r,cx,cy-r );
	SelectObject( hMemDC, hOldPen );
	DeleteObject( hPen );
	_IsGraphChange = TRUE;
}
void SetPixelHU( int x, int y )
{
	SetPixelV( hMemDC, x, y, _PenColor );
	_IsGraphChange = TRUE;
}
void ShowWindowHU( int mode )
{
	switch( mode )
	{
		case 0:
			if( !_IsGraphShow ) return;
			ShowWindow( hGWnd, SW_HIDE ); break;
		case 1:
			if( !_IsGraphShow ) return;
			ShowWindow( hGWnd, SW_SHOW ); break;
		case 2:
			ShowWindow( hMWnd, SW_HIDE ); break;
		case 3:
			ShowWindow( hMWnd, SW_SHOW ); break;
	}
}
void ClearWindowHU( void )
{
	int n;
	RECT r;

	switch( _GraphBkColor )
	{
		case BK_BLACK :
			n = BLACK_BRUSH; break;
		case BK_GRAY  :
			n = LTGRAY_BRUSH; break;
		case BK_WHITE :
			n = WHITE_BRUSH; break;
		default       : 
			n = BLACK_BRUSH; break;
	}
	SetRect( &r, 0,0,_GWinSizeX,_GWinSizeY );
	FillRect(hMemDC, &r, GetStockObject( n )); // p.676
	_IsGraphChange = TRUE;
}
void CreateGraphicWindowHU( int width, int height, int bk )
{
	static BOOL Flag = FALSE;
	int n;
	HDC hDC;
	RECT r;

	_GraphBkColor = bk;
	switch( bk )
	{
		case BK_BLACK :
			n = BLACK_BRUSH; _PenColor = RGB(255,255,255); break;
		case BK_GRAY  :
			n = LTGRAY_BRUSH; _PenColor = RGB(0,0,0); break;
		case BK_WHITE :
			n = WHITE_BRUSH; _PenColor = RGB(0,0,0); break;
		default       : 
			n = BLACK_BRUSH;_PenColor = RGB(255,255,255); break;
	}
	SetClassLong( hGWnd, GCL_HBRBACKGROUND, (long)GetStockObject( n ) );

	_GWinSizeX = width; _GWinSizeY = height;
	SetWindowPos( hGWnd, 0,0,0, width, height, SWP_NOMOVE|SWP_NOZORDER ); 
	GetClientRect( hGWnd, &r);
	width += width - r.right; height += height - r.bottom ;
	SetWindowPos( hGWnd, 0,0,0, width, height, SWP_NOMOVE|SWP_NOZORDER ); 
	if( Flag ){ 
		DeleteObject( hBitmap ); hBitmap = 0;
		DeleteObject( hMemDC ); hMemDC = 0;
	}
	hDC = GetDC( hGWnd );
	hBitmap = CreateCompatibleBitmap( hDC, _GWinSizeX, _GWinSizeY );  
	if( !hBitmap ){
		MsgHU("Failed Graphic window");
	}
	hMemDC = CreateCompatibleDC( hDC );  
	SelectObject( hMemDC, hBitmap );  
	r.left = 0;r.top = 0; r.right  = _GWinSizeX; r.bottom = _GWinSizeY;
	FillRect(hMemDC, &r, GetStockObject( n ));  
	  
	switch( bk )
	{
		case BK_BLACK : SetBkColor( hMemDC, RGB(0,0,0) ); break;
		case BK_GRAY  :	SetBkColor( hMemDC, RGB(192,192,192) );	break;
		case BK_WHITE :	SetBkColor( hMemDC, RGB(255,255,255) ); break;
		default       : SetBkColor( hMemDC, RGB(0,0,0) ); break;
	}
	ChangeFontHU( _DEF_GRA_FONT_TYPE, _DEF_GRA_FONT_SIZE, 0, 0, 0, 0 );
	ClearWindowHU();
	Flag = TRUE;
	_IsGraphShow = TRUE;
	ShowWindow( hGWnd, SW_RESTORE );  
}
void FontSizeHU( int size )
{
	_GFontInfo->lfHeight = size;
}
void ChangeFontHU( char *Type, int Size, int Round , int Bold, int Italic, int Line )
{
	int i;

	i = 0;
	if( strcmp( Type,"" )==0 || strcmp( Type, "MS" )==0 ) i = 1;
	if( strcmp( Type,"SVbN" )==0 || strcmp( Type,"޼" )==0 ) i = 2;
	switch( i )
	{
		case 0: lstrcpy(_GFontInfo->lfFaceName,Type);
			break;
		case 1: lstrcpy(_GFontInfo->lfFaceName,"W");
			break;
		case 2: lstrcpy(_GFontInfo->lfFaceName,"WSVbN");
			break;
	}

	_GFontInfo->lfWeight=(Bold==0)*FW_NORMAL+(Bold==1)*FW_BOLD;
	_GFontInfo->lfEscapement=Round*10;
	_GFontInfo->lfWidth=0;
	_GFontInfo->lfHeight=Size;
	_GFontInfo->lfItalic=Italic;
	_GFontInfo->lfUnderline=Line;
	_GFontInfo->lfCharSet=SHIFTJIS_CHARSET;
}

void GetFileNameHU( char *s, int mode )
{
	OPENFILENAME ofn;
	BOOL Res;
	static char szFileName[_MAX_PATH], szFileTitle[_MAX_PATH];

	memset( &ofn, 0, sizeof( OPENFILENAME ) );
	ofn.lStructSize    = sizeof( OPENFILENAME );
	ofn.hwndOwner      = hMWnd;
	ofn.lpstrFilter    = "SĂ̧ {*.*}\0*.*\0"\
	                     "÷̧ {*.txt}\0*.txt\0"\
					     "ޯϯ{*.bmp}\0*.bmp\0\0";
	ofn.lpstrFile      = szFileName;
	ofn.nMaxFile       = _MAX_PATH;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle  = _MAX_PATH;
	ofn.Flags          = OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt    = "*";

	if( mode==0 ){
		Res = GetOpenFileName( &ofn );
	}else{
		Res = GetSaveFileName( &ofn );
	}
	if( Res ){
		strcpy( s,szFileName );
	}else{
		*s = '\0';
	}
}
void TextWindowSizeHU( int ix, int iy, int width, int height )
{
	MoveWindow( hMWnd, ix, iy, width, height, TRUE );
}

int printfHU(const char *format,... ) 
{
	char s[_MAX_ONE_LINE+1], tb[_MAX_ONE_LINE+1];
	char *ptb;
	int i,BuffLen,CatLen;
	va_list args; 
	va_start( args, format );
	vsprintf( s, format, args );
	va_end( args );
	BuffLen = strlen( _TextBuff[_CuBuffPos] );
	CatLen = strlen( s );
	strcpy( tb, _TextBuff[_CuBuffPos] ); 
	ptb = tb + BuffLen; 

	for(i=0;i<=CatLen;i++){ 
		if( s[i]=='\n' || BuffLen+i >= _MAX_ONE_LINE){ 
			*ptb = '\0'; 
			strcpy( _TextBuff[_CuBuffPos], tb );
			if( ++_CuBuffPos >= _MAX_TEXT_LINE ) _CuBuffPos = 0; 
			if( ++_CuBuffHeight > _MAX_TEXT_LINE ){ 
				_CuBuffHeight = _MAX_TEXT_LINE;
				if( ++_WinTopPos >= _MAX_TEXT_LINE ) _WinTopPos = 0;
				if( ++_CuBuffTopPos >= _MAX_TEXT_LINE ) _CuBuffTopPos = 0;
			}
			if( _WinHeight <= _CuBuffHeight){
				_RelativePos = _CuBuffHeight - _WinHeight;
			}
			if( s[i]!='\n' ){
				tb[0] = s[i]; ptb = tb + 1;
			}else{
				tb[0] = '\0'; ptb = tb;
			}
			BuffLen = 0;
			continue;
		}
		*ptb = s[i];
		ptb++;
	}
	strcpy( _TextBuff[_CuBuffPos], tb );
	_IsPrintfChange = TRUE;

	return CatLen; 
}

int scanfHU( const char *format,... )
{
	char *ptr;
	int i,count;
	va_list marker;
	va_start( marker, format );    
	strcpy( _scanfFormat, format );
	count = 0; ptr = _scanfFormat;
	while( *ptr!='\0' ){ 
		if( *ptr=='%' ) count++;
		ptr++;
	}
	if( count>40 ) count = 40;
	for(i=0;i<count;i++){
		_lpscanfPtr[i] = (void *)va_arg( marker, void *);
	}
	_lpscanfPtr[count] = NULL;

	va_end( marker );              

	if( _ScanfBuffLen>0 ){ 
		_IsSBuffDarw = FALSE;
		_scanfHU_2();
		return 0;
	}

	_IsEditActive = TRUE;

	while( _IsEditActive ) EventHU();
	return 0; 
}
void _scanfHU_2( void )
{	
	char cc[_MAX_ONE_LINE+1],word[_MAX_ONE_LINE+1];
	char *ptr, *pf, *pw, *dummy;
	int i,n;

	ptr = _ScanfBuff;
	pf = _scanfFormat;
	i = 0;
	while( *pf!='\0' ){ 
		while( *ptr==' ' || *ptr==',' ){ 
			if( *(++ptr)=='\0' ) break;
		}
		pw = word;
		while( !(*ptr==' ' || *ptr==',' || *ptr=='\0') ){
			*pw = *ptr; pw++; ptr++;
		}
		*pw = '\0';

		while( *pf!='%' ){				
			if( *pf=='\0' ) return;
			pf++;
		}
		pf++;
		while( isdigit(*pf) ) pf++;
		switch( *pf )
		{
		case 'd': *((int *)_lpscanfPtr[i]) = (int)strtol( word, &dummy, 10 );
			break;
		case 'f': *((float *)_lpscanfPtr[i]) = (float)strtod( word, &dummy );
			break;
		case 'l': pf++;
			if( *pf=='d' ) 	*((long *)_lpscanfPtr[i]) = strtol( word, &dummy, 10 );
			else           	*((double *)_lpscanfPtr[i]) = strtod( word, &dummy );
			break;
		case 'c': 	*((char *)_lpscanfPtr[i]) = word[0];
			break;
		case 's': 	strcpy( (char *)_lpscanfPtr[i], word );
			break;
		}
		pf++;	i++;
	}

	n = i;
	ptr = _ScanfBuff;
	for(i=0;i<n;i++){
		while( *ptr==' ' || *ptr==',' ){ 	if( *(ptr)=='\0' ) break;
			ptr++;
		}
		while( *ptr!=' ' && *ptr!=',' ){ 	if( *(ptr)=='\0' ) break;
			ptr++;
		}
		while( *ptr==' ' || *ptr==',' ){ 	if( *(ptr)=='\0' ) break;
			ptr++;
		}
	}
	if( *(ptr)=='\0' ){ 	if( _IsSBuffDarw ) printf("%s",_ScanfBuff );
		_ScanfBuff[0] = '\0'; _ScanfBuffLen = 0;
		printf("\n");
	}else{ 	strcpy( cc, ptr );
		ptr = '\0';
		if( _IsSBuffDarw ) printf("%s",_ScanfBuff );
		strcpy( _ScanfBuff, cc );
		_ScanfBuffLen = strlen( _ScanfBuff );
	}

}

void DrawTextWindowHU( void )
{
	HDC hDC;
	HFONT hOldFont;
	int i,w;
	SCROLLINFO si;

	hDC = GetDC( hMWnd );

	SendMessage( hMWnd, WM_ERASEBKGND, (UINT)hDC, 0 );
	_hFont = CreateFontIndirect( _MFontInfo );
	hOldFont = SelectObject( hDC, _hFont );

	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
	si.nPos = _RelativePos;
	si.nMin = 0;
	si.nMax = _CuBuffHeight - 1;
	si.nPage = _WinHeight;
	SetScrollInfo( hMWnd, SB_VERT, &si, TRUE );

	if( _WinHeight>=_CuBuffHeight ){ 
		for(i=0;i<_CuBuffHeight;i++){ 
			if( i>=_MAX_TEXT_LINE ) break;
			_LastYPos = i*_FontSizeY;
			TextOut( hDC, 0, _LastYPos, _TextBuff[i], strlen(_TextBuff[i]));
		}
	}else{ 
		w = _CuBuffTopPos + _RelativePos;
		if( w>=_MAX_TEXT_LINE ) w -= _MAX_TEXT_LINE;
		for(i=0;i<_WinHeight;i++){ 
			_LastYPos = i*_FontSizeY;
			TextOut( hDC, 0, _LastYPos, _TextBuff[w], strlen(_TextBuff[w]));
			if( ++w>=_MAX_TEXT_LINE ) w = 0;
		}
	}

	SelectObject( hDC, hOldFont ); 
	DeleteObject( hOldFont );
	DeleteObject( _hFont ); _hFont = 0;

	if( _IsEditActive ){
		if( _RelativePos == _CuBuffHeight -_WinHeight ||
			_CuBuffHeight < _WinHeight ){ 
			_IsLastPosVisible = TRUE;
			_DrawScanfBufferHU();
		}
	}
	ReleaseDC( hMWnd,hDC );
}

void _ChangeFontSizeHU( int size )
{
	_MFontInfo->lfHeight = size;
}

void EventHU( void )
{
	MSG msg;

	if( PeekMessage(&msg, NULL,0,0,PM_NOREMOVE) ){
		if( !GetMessage( &msg, NULL, 0, 0 ) ) return;
		TranslateMessage( &msg );
		DispatchMessage( &msg );        
	}
}
void ResizeTextWindowHU( void )
{
	RECT r;

	if( _FontSizeY < 2 ) return;
	GetClientRect( hMWnd, &r );
	_WinHeight = (int)((r.bottom - r.top)/_FontSizeY);
	if( _WinHeight <= _CuBuffHeight ){
		_RelativePos = _CuBuffHeight - _WinHeight;
	}else _RelativePos = 0;	
}
void _SaveGraphicHU( void )
{
	char s[256],ch[100];
	FILE *fp;
	int i;

	GetFileNameHU(s,1);
	if( strlen(s)==0 ) return;
 
	if( (fp = fopen( s, "r" )) != NULL ){ 
		fclose( fp );
		sprintf( ch, "\n Same file name exists. \n\n Overwrite OK? \n\n");
		i = MessageBox( hMWnd, ch, "OverWrite?", MB_OKCANCEL |MB_ICONQUESTION );
		if( i== IDCANCEL ) return;
	}

	SaveGraphicWindowHU( s );

	MsgHU(" Saved Graphic ");

}
void _SaveTextBufferHU( void )
{
	int i,w;
	char s[256],ch[100];
	FILE *fp;

	GetFileNameHU(s,1);
	if( strlen(s)==0 ) return;
 
	if( (fp = fopen( s, "r" )) != NULL ){ 
		fclose( fp );
		sprintf( ch, "\n Same file name exists. \n\n Overwrite OK? \n\n");
		i = MessageBox( hMWnd, ch, "OverWrite?", MB_OKCANCEL |MB_ICONQUESTION );
		if( i== IDCANCEL ) return;
	}
	fp = fopen( s, "w" );

	w = _WinTopPos;
	for(i=0;i<_CuBuffHeight;i++){
		fprintf( fp, "%s\n", _TextBuff[w] );
		if( ++w>=_MAX_TEXT_LINE ) w = 0;
	}
	fclose( fp );
	MsgHU("Saved TextBuffer");
}
void TitleHU( const char *s )
{
	SetWindowText( hMWnd, s );
}
void MsgHU( const char *format,... )
{
	char s[256];
	va_list args; 
	va_start( args, format );
	vsprintf( s, format, args );
	va_end( args );
	MessageBox(hMWnd,s,"WinHU Message",MB_ICONINFORMATION);
}
void GetMouseHU( int *x, int *y, int *button )
{
	EventHU();
	if( _IsLButtonDown ){ 
		_IsLButtonDown = FALSE; _IsRButtonDown = FALSE;
		*button = 1;
		*x = _MousePosL.x; *y = _MousePosL.y;
		return;
	}
	if( _IsRButtonDown ){ 
		_IsLButtonDown = FALSE; _IsRButtonDown = FALSE;
		*button = 2;
		*x = _MousePosR.x; *y = _MousePosR.y;
		return;
	}
	
	*button = 0;
	*x = -1; *y = -1;
}
void FlushHU( void )
{
	HDC hDC;
	int i;
	
	_IsGraphChange = FALSE;
	hDC = GetDC(hGWnd); 
	BitBlt(hDC, 0,0, _GWinSizeX,_GWinSizeY, hMemDC, 0,0, SRCCOPY);
	ReleaseDC( hGWnd, hDC );
	for(i=0;i<_ButtonNumber;i++){
		ShowWindow( _hButton[i], SW_HIDE );
		ShowWindow( _hButton[i], SW_SHOWNA );
	}
}
void CreateButtonHU( int Index, char *s, int x, int y, int width, int height )
{
	if( _ButtonNumber>=_BUTTON_NUMBER_MAX ){
		MsgHU("\n Number of Buttons should be less than %d",_BUTTON_NUMBER_MAX);
		return;
	}
	_hButton[_ButtonNumber] = CreateWindow("BUTTON",s
		,WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON
		,x,y,width,height, hGWnd, (HMENU)Index, _ghInstance, NULL);

	_ButtonNumber++;
}
void SetButtonFuncHU( void (*f)(int) )
{
	ButtonFuncNameHU = f;
}
void _DrawScanfBufferHU( void )
{
	HDC hDC;
	HFONT hOldFont;
	char s[_MAX_SCANF_BUFF];
	
	if( !_IsLastPosVisible ) return;
	hDC = GetDC( hMWnd );
	_hFont = CreateFontIndirect( _MFontInfo );
	hOldFont = SelectObject( hDC, _hFont );
	strcpy( s, _TextBuff[_CuBuffPos] );
	strcat( s, _ScanfBuff );
	if( _IsCaretVisible ) strcat( s,"|   " ); else strcat( s,"    " );
	TextOut( hDC, 0, _LastYPos, s, strlen( s ) );
	ReleaseDC( hMWnd,hDC );

	SelectObject( hDC, hOldFont );
	DeleteObject( hOldFont );
	DeleteObject( _hFont ); _hFont = 0;
}
void SaveGraphicWindowHU( char *FileName )
{
	LPBITMAPINFO	lpbinfo;	
	BYTE*			lpBits;		
	UINT			binfoSize,lpbitsSize;
	BITMAPFILEHEADER   bif;
	BITMAPINFOHEADER   *lpbi;
	HDC hDC,hMDC;
	HBITMAP hB;
	HANDLE fh;
	DWORD dwWritten;

	binfoSize = ( sizeof(BITMAPINFOHEADER) );
	lpbinfo = (BITMAPINFO *)GlobalAllocPtr( GMEM_MOVEABLE,binfoSize );
	if( !lpbinfo ){
		MsgHU("Failed to save");
		return;
	}
	lpbitsSize = ((_GWinSizeX + 3) & ~3) * _GWinSizeY * 3;

	lpbi = (BITMAPINFOHEADER *)lpbinfo;
	lpbi->biSize = sizeof( BITMAPINFOHEADER );
	lpbi->biWidth = _GWinSizeX;
	lpbi->biHeight = _GWinSizeY;
	lpbi->biPlanes = 1;
	lpbi->biBitCount = 24;
	lpbi->biCompression = BI_RGB;
	lpbi->biSizeImage = 0;
	lpbi->biXPelsPerMeter = 0;
	lpbi->biYPelsPerMeter = 0;
	lpbi->biClrUsed = 0;
	lpbi->biClrImportant = 0;

	hB = CreateDIBSection( hMemDC, lpbinfo,DIB_RGB_COLORS,
					(void**)&lpBits, NULL, 0 );
	hDC = GetDC( hGWnd );
	hMDC = CreateCompatibleDC( hDC );
	SelectObject( hMDC, hB );

	BitBlt( hMDC, 0,0, _GWinSizeX, _GWinSizeY, hMemDC, 0,0, SRCCOPY );

	ReleaseDC( hGWnd, hDC );
	DeleteDC( hMDC );

	fh = CreateFile( FileName, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS,
					FILE_ATTRIBUTE_NORMAL, NULL );
	if (fh == INVALID_HANDLE_VALUE ){ 
		MsgHU("Failed to nopen file.");
		return;
	}
	bif.bfType = 0x4D42; 
	bif.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbitsSize;
	bif.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	WriteFile( fh, &bif, sizeof(BITMAPFILEHEADER), &dwWritten, NULL );
	WriteFile( fh, lpbi, sizeof(BITMAPINFOHEADER), &dwWritten, NULL );
	WriteFile( fh, lpBits, lpbitsSize, &dwWritten, NULL );

	CloseHandle( fh );
	if( lpbinfo != NULL ) GlobalFreePtr( lpbinfo );
}
BOOL _InitAppHU( HINSTANCE hThisInstance, int nCmdShow )
{
	WNDCLASS    wndclass;
	char		szAppName[80] = APP_WIN_CLASS;
	int			x,y;

	wndclass.style         = CS_HREDRAW|CS_VREDRAW;
	wndclass.lpfnWndProc   = WndFunc;		 
	wndclass.cbClsExtra    = 0;			 
	wndclass.cbWndExtra    = 0;			 
	wndclass.hInstance     = hThisInstance; 
	wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = szAppName;
	RegisterClass (&wndclass);

	hMWnd = CreateWindow(
				szAppName,             
				DEFAULT_CAPTION,	   
				WS_OVERLAPPEDWINDOW |  
				WS_VSCROLL,
				CW_USEDEFAULT,         
				CW_USEDEFAULT,         
				_DEFAULT_TEXT_X,       
				_DEFAULT_TEXT_Y,       
				NULL,                  
				NULL,                  
				hThisInstance,         
				NULL);                 
	if (!hMWnd) return FALSE;

	x = GetSystemMetrics( SM_CXSCREEN )/2;
	y = GetSystemMetrics( SM_CYSCREEN )/2;
	y = y - _DEFAULT_TEXT_Y /2;
	x = x - _DEFAULT_TEXT_X /2;
	MoveWindow( hMWnd, x, y, _DEFAULT_TEXT_X, _DEFAULT_TEXT_Y, FALSE );
	ShowWindow( hMWnd, nCmdShow );

	wndclass.style         = CS_NOCLOSE|CS_OWNDC;
	wndclass.lpfnWndProc   = WndGraFunc;	 
	wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
	wndclass.lpszClassName = APP_GRA_CLASS;
	RegisterClass (&wndclass);
	hGWnd = CreateWindow(
				APP_GRA_CLASS,           
				DEFAULT_GRA_CAP,	   
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX,
				CW_USEDEFAULT,         
				CW_USEDEFAULT,         
				_DEFAULT_TEXT_X,       
				_DEFAULT_TEXT_Y,       
				NULL,                  
				NULL,                  
				hThisInstance,         
				NULL);                 
	if (!hGWnd) return FALSE;
	x -= 24; y -= 24;
	if( x<0 ) x = 0;
	if( y<0 ) y = 0;
	MoveWindow( hGWnd, INITGx, INITGy, _DEFAULT_TEXT_X, _DEFAULT_TEXT_Y, FALSE );

	hMenu = CreatePopupMenu();
	InsertMenu(hMenu, 0, MF_BYPOSITION, IDM_FONT_TINY, " Tiny Size");
	InsertMenu(hMenu, 1, MF_BYPOSITION, IDM_FONT_SMALL, " Small Size");
	InsertMenu(hMenu, 2, MF_BYPOSITION, IDM_FONT_DEFAULT, " Default Size");
	InsertMenu(hMenu, 3, MF_BYPOSITION, IDM_FONT_LARGE, " Large Size");
	InsertMenu(hMenu, 4, MF_BYPOSITION, IDM_FONT_HUGE, " Huge Size");
	InsertMenu(hMenu, 5, MF_BYPOSITION | MFT_SEPARATOR, 999, "");	
	InsertMenu(hMenu, 6, MF_BYPOSITION, IDM_TEXT_SAVE, " Save TextBuffer File");
	InsertMenu(hMenu, 7, MF_BYPOSITION, IDM_GRAPH_SAVE, " Save Graphic File");
	InsertMenu(hMenu, 8, MF_BYPOSITION | MFT_SEPARATOR, 999, "");	
	InsertMenu(hMenu, 9, MF_BYPOSITION , IDM_EXIT, "  &Exit ");	

	_CuBuffPos = 0; _WinTopPos = 0; _RelativePos = 0;
	_CuBuffHeight = 1;
	_TextBuff[0][0] = '\0';

	_FontSizeY = _DEFAULT_FONT_SIZE;
	_MFontInfo = (PLOGFONT)GlobalAlloc(GPTR,sizeof(LOGFONT));
	lstrcpy(_MFontInfo->lfFaceName,"WSVbN");

	_MFontInfo->lfWeight = (0)*FW_NORMAL + (0)*FW_BOLD;
	_MFontInfo->lfEscapement = 0*10;
	_MFontInfo->lfWidth = 0;
	_MFontInfo->lfHeight = _DEFAULT_FONT_SIZE;
	_MFontInfo->lfItalic = 0;
	_MFontInfo->lfUnderline = 0;
	_MFontInfo->lfCharSet = SHIFTJIS_CHARSET;
	_ChangeFontSizeHU( _FontSizeY );

	_GFontInfo = (PLOGFONT)GlobalAlloc(GPTR,sizeof(LOGFONT));
	ResizeTextWindowHU();

	return TRUE;
}

int WINAPI WinMain( HINSTANCE hThisInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow )
{
	MSG msg;

	if ( !_InitAppHU( hThisInstance, nCmdShow ) ) return FALSE;
	_ghInstance = hThisInstance;

	mainHU();

	while(1){
		if( PeekMessage(&msg, NULL,0,0,PM_NOREMOVE) ){
			if( !GetMessage( &msg, NULL, 0, 0 ) ) return msg.wParam;
			TranslateMessage( &msg );
			DispatchMessage( &msg );        
		}else{
			
		}
	}
	return msg.wParam;
}

LRESULT CALLBACK WndFunc(HWND hwnd, UINT message, WPARAM wParam,LPARAM lParam)
{
	static unsigned long CuTime = 0;
	HDC         hDC;
	PAINTSTRUCT ps;
	POINT pt;
	int i;
	char s[_MAX_SCANF_BUFF];

	switch (message){
		case WM_PAINT:
			DrawTextWindowHU();
			hDC = BeginPaint (hwnd, &ps);

			EndPaint (hwnd, &ps);
			break;
		case WM_CREATE:
			_TimerID = SetTimer( hMWnd, 1, _TIMER_PER_WAIT, (TIMERPROC)_TimerRTFProc );
			break;

		case WM_SIZE:
			ResizeTextWindowHU();
			DrawTextWindowHU();
			break;

		case WM_VSCROLL:
			i = _RelativePos;
			_IsLastPosVisible = FALSE;
			switch( LOWORD(wParam) )
			{
				case SB_ENDSCROLL:
					break;
				case SB_LINEUP:
					--_RelativePos;
					break;
				case SB_LINEDOWN:
					++_RelativePos;
					break;
				case SB_PAGEUP:
					_RelativePos -= _WinHeight;
					break;
				case SB_PAGEDOWN:
					_RelativePos += _WinHeight;
					break;
				default:
					_RelativePos = HIWORD(wParam);
					break;
			}
			if( _RelativePos < 0 ) _RelativePos = 0;
			if( _RelativePos >= _CuBuffHeight -_WinHeight ){
				_RelativePos = _CuBuffHeight -_WinHeight;
				_IsLastPosVisible = TRUE;
			}
			if( i!=_RelativePos ) DrawTextWindowHU();
			break;

		case WM_COMMAND:
			switch( wParam )
			{
				case IDM_FONT_TINY:
					_FontSizeY = 9;
					_ChangeFontSizeHU( _FontSizeY );ResizeTextWindowHU();
					DrawTextWindowHU();
					break;
				case IDM_FONT_SMALL:
					_FontSizeY = 12;
					_ChangeFontSizeHU( _FontSizeY );ResizeTextWindowHU();
					DrawTextWindowHU();
					break;
				case IDM_FONT_DEFAULT:
					_FontSizeY = _DEFAULT_FONT_SIZE;
					_ChangeFontSizeHU( _FontSizeY );ResizeTextWindowHU();
					DrawTextWindowHU();
					break;
				case IDM_FONT_LARGE:
					_FontSizeY = _DEFAULT_FONT_SIZE*2;
					_ChangeFontSizeHU( _FontSizeY );ResizeTextWindowHU();
					DrawTextWindowHU();
					break;
				case IDM_FONT_HUGE:
					_FontSizeY = _DEFAULT_FONT_SIZE*3;
					_ChangeFontSizeHU( _FontSizeY );ResizeTextWindowHU();
					DrawTextWindowHU();
					break;
				case IDM_TEXT_SAVE:
					_SaveTextBufferHU();
					break;
				case IDM_GRAPH_SAVE:
					if( _IsGraphShow ){
						_SaveGraphicHU();
					}else{
						MsgHU("Graphic window is not displayed.");
					}
					break;
				case IDM_EXIT:
					i = MessageBox( hMWnd, "\n End ? \n\n", 
								"EXIT?", MB_OKCANCEL |MB_ICONQUESTION );
					if( i== IDCANCEL ) break;
					DestroyWindow( hMWnd );
					break;

			}
			break;

		case WM_RBUTTONDOWN:
			pt.x = LOWORD( lParam );
			pt.y = HIWORD( lParam );
			ClientToScreen( hMWnd, &pt );
			TrackPopupMenu( hMenu, TPM_RIGHTBUTTON | TPM_CENTERALIGN, 
							pt.x, pt.y, 0,hMWnd, NULL );//p.236
			break;

		case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_ESCAPE:
					DestroyWindow( hMWnd );
					break;
				case VK_F12:
					break;
			}
			break;

		case WM_KEYUP:
			break;

		case WM_CHAR:
			if( !_IsEditActive ) break;  
			s[0] = (char)wParam;
			if( s[0]<0x20 && s[0]>0 ){  
				switch((char)wParam){
				case 13:  
					_IsEditActive = FALSE;
					_IsSBuffDarw = TRUE; 
					_scanfHU_2();
					DrawTextWindowHU();
					return DefWindowProc (hwnd, message, wParam, lParam);
				case 16:  
				case 8:  
					if( _ScanfBuffLen==0 ) break;
					_ScanfBuff[--_ScanfBuffLen] = '\0';
					break;
				}
			}else{
				_ScanfBuff[_ScanfBuffLen] = (char)wParam;
				_ScanfBuff[++_ScanfBuffLen] = '\0';
			}
			   if( _RelativePos < _CuBuffHeight -_WinHeight ){ 
				_RelativePos = _CuBuffHeight -_WinHeight;
				DrawTextWindowHU();
			}
			_IsLastPosVisible = TRUE;
			_DrawScanfBufferHU();

			break;

		case WM_ACTIVATE:
			break;
				
		case WM_DESTROY:
			_IsEditActive = FALSE;
			if( _hFont ) DeleteObject( _hFont ); 
			if( _MFontInfo ){
				GlobalFree((LOCALHANDLE)_MFontInfo); _MFontInfo = NULL;
			}
			if( _GFontInfo ){
				GlobalFree((LOCALHANDLE)_GFontInfo); _GFontInfo = NULL;
			}
			ShowCursor(TRUE);
			KillTimer( hMWnd, _TimerID );
			DestroyWindow( hGWnd );
			PostQuitMessage(0);
			exit(0);
			break;

		default:
			return ( DefWindowProc (hwnd, message, wParam, lParam) );
	}
	
	return ( 0L );

}

LRESULT CALLBACK WndGraFunc(HWND hwnd, UINT message, WPARAM wParam,LPARAM lParam)
{
	HDC         hDC;
	PAINTSTRUCT ps;
	int i;

	switch (message){
		case WM_PAINT:
			hDC = BeginPaint (hwnd, &ps);
			BitBlt(hDC, 0,0, _GWinSizeX, _GWinSizeY, hMemDC, 0,0, SRCCOPY);
			EndPaint (hwnd, &ps);
			for(i=0;i<_ButtonNumber;i++){
				ShowWindow( _hButton[i], SW_HIDE );
				ShowWindow( _hButton[i], SW_SHOWNA );
			}
			_IsGraphChange = FALSE;
			break;
		case WM_COMMAND:
			ButtonFuncNameHU( (int)wParam );
			break;
		case WM_LBUTTONDOWN: 
			_IsLButtonDown = TRUE;
			GetCursorPos( &_MousePosL );
			ScreenToClient( hwnd, &_MousePosL );
			break;
		case WM_RBUTTONDOWN: 
			_IsRButtonDown = TRUE;
			GetCursorPos( &_MousePosR );
			ScreenToClient( hwnd, &_MousePosR );
			break;
		case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_ESCAPE:
					DestroyWindow( hMWnd );
					break;
				case VK_F12:
					break;
			}
			break;
		case WM_DESTROY:
			if( hMemDC ) DeleteDC( hMemDC );
			if( hBitmap ) DeleteObject( hBitmap );
			if( _hGFont ) DeleteObject( _hGFont );
			PostQuitMessage(0);
			break;
		default:
			return ( DefWindowProc (hwnd, message, wParam, lParam) );
	}

	return ( DefWindowProc (hwnd, message, wParam, lParam) );
}
void CALLBACK _TimerRTFProc( HWND hWnd, UINT uTMsg, UINT uTID, DWORD dwTime )
{
	HDC hDC;
	int i;

	if( _IsGraphChange ){ 
		_IsGraphChange = FALSE;
		hDC = GetDC(hGWnd); 
		BitBlt(hDC, 0,0, _GWinSizeX,_GWinSizeY, hMemDC, 0,0, SRCCOPY);
		ReleaseDC( hGWnd, hDC );
		for(i=0;i<_ButtonNumber;i++){
			ShowWindow( _hButton[i], SW_HIDE );
			ShowWindow( _hButton[i], SW_SHOWNA );
		}
	}
	if( _IsPrintfChange ){ 
		_IsPrintfChange = FALSE;
		DrawTextWindowHU();
	}
	_IsCaretVisible = !_IsCaretVisible;
	if( _IsEditActive ){_DrawScanfBufferHU();}
}
