// SimpleBackProjection.c
				   
#include "HU.h" 

void Main(void){

	char		f[100], yn, a, b;
	int			i,j,c,max,maxp,frame,ii,jj,ir,jr,RJ,MAXFRAME,T,px,py;
	double 		PAI,dT,rot,I,J;
	static int	Proj[80][80][40], SimpleBP[80][80], Simple_Sino[80][80], Sino[80][80], Pth[80][80][40];

	FILE		*fp;

		
	TextWindow(2,20,300,600);	Title("SPECT Simple BackProjection");
	printf("SPECT Simple BackProjection");

START:

//------------------- Load projection image ----------------------------------------

	MAXFRAME = 32;

	printf("\n\n Load projection file \n\n"); GetFileName(f, 0); fp=fopen(f,"rb");

	max=0;

	for(frame=0;frame<MAXFRAME;frame++){for(j=0;j<64;j++){for(i=0;i<64;i++){
	
		a=fgetc(fp); b=fgetc(fp);  c= a*256 + b;  if(c<0)c=0;
     		
		Proj[i][j][frame]=c;  if(c>max)max=c;

	}}} 
	fclose(fp);

//--------------------------- DISP projection -------------------------------------------

GraphicWindow(1050,800,BK_BLACK);
	
	for(frame=0;frame<MAXFRAME;frame++){ 
	
		px=65*(frame-16*(frame/16));  py=65*(frame/16); 	

		for(j=0;j<64;j++){ for(i=0;i<64;i++){

			c = Proj[i][j][frame] * 800/max;  if(c>255)c=255;

			SetColor(RGB(c,c,c)); SetPixel(i+px,j+py);
		}}
	}

//----------------------- Rotate Projection images -----------------------------

	for(frame=0;frame<MAXFRAME;frame++){
		
		for(j=0;j<64;j++){ for(i=0;i<64;i++){ 	

			c = Proj[i][j][frame] * 800/max;  if(c>255)c=255;

			for(ii=0;ii<=3;ii++){ for(jj=0;jj<=3;jj++){
			
				SetColor(RGB(c,c,c));	SetPixel(4*i+ii,4*j+jj+130);
			}}
		}}
		printf(" Rotate Projection %2d", frame+1 ); scanf("%c",&yn);
	}

//----------------------- Set Reconstruction Slice -----------------------------

SET_RECON_SLICE:

	for(j=0;j<64;j++){ for(i=0;i<64;i++){ 	

		c = Proj[i][j][0] * 800/max;  if(c>255)c=255;

		for(ii=0;ii<=3;ii++){ for(jj=0;jj<=3;jj++){
		
			SetColor(RGB(c,c,c));	SetPixel(4*i+ii,4*j+jj+130);
		}}
	}}

	printf("\n\n Reconstruction position j = ");scanf("%d",&RJ);
	if( RJ<1 || RJ>64 )goto SET_RECON_SLICE;

	SetColor(RED); PenWidth(3); Line(0, 130+4*RJ, 250, 130+4*RJ); PenWidth(1);

//--------------------------- Disp Sinogram ----------------------------------

	for(frame=0; frame<MAXFRAME; frame++){ for(i=0;i<64;i++){
		
		Sino[i][frame] = Proj[i][RJ][frame];
	}}
	
	for(j=0;j<64;j++){ for(i=0;i<64;i++){ 	

		c = Sino[i][j] * 800/max;  if(c>255)c=255;

			for(ii=0;ii<=3;ii++){ for(jj=0;jj<=3;jj++){
			
				SetColor(RGB(c,c,c)); SetPixel(4*i+ii+260,4*j+jj+140);
			}}

	}}

	SetColor(WHITE); FontSize(30); DrawString(300, 300, "Sinogram" );
	
	printf("\nReconstruction slice OK? \n(yes: enter, no: n) ");scanf("%c",&yn);

	if(yn=='n'||yn=='N')goto SET_RECON_SLICE;

//---------------------- Generate Pth[][][] (P) data ---------------------------

	PAI = 3.1415926/180.0;  	dT = 180.0/(double)MAXFRAME;

	for(T=0;T<MAXFRAME;T++){for(j=0;j<64;j++){for(i=0;i<64;i++){Pth[i][j][T]=-1;}}}
 
	for(T=0; T<MAXFRAME;T++){ 

		for(j=0;j<64;j++){for(i=0;i<64;i++){ Simple_Sino[i][j] = Sino[i][T]; }} 

		rot = (double)T * dT * PAI ; 

		for(j=0;j<64;j++){for(i=0;i<64;i++){ I = (double)i;  J = (double)j;
		
			ir=(int)((I-31.5)*cos(rot)-(J-31.5)*sin(rot)+31.5);
			jr=(int)((I-31.5)*sin(rot)+(J-31.5)*cos(rot)+31.5);
		
			if(ir>=0 && ir<64 && jr>=0 && jr<64)Pth[ir][jr][T]=Simple_Sino[i][j];
		}}
	}

	for(T=0; T<MAXFRAME;T++){ 
	
		for(j=1;j<63;j++){for(i=1;i<63;i++){
	
		if(Pth[i][j][T]==-1 && Pth[i-1][j][T]!=-1 && Pth[i+1][j][T]!=-1)Pth[i][j][T]=(Pth[i-1][j][T]+Pth[i+1][j][T])/2;
		if(Pth[i][j][T]==-1 && Pth[i][j-1][T]!=-1 && Pth[i][j+1][T]!=-1)Pth[i][j][T]=(Pth[i][j-1][T]+Pth[i][j+1][T])/2;
		}}

		for(j=0;j<64;j++){for(i=0;i<64;i++){if(Pth[i][j][T]<0)Pth[i][j][T]=0; }}
	}

//---------------------- Disp Projection Pth-----------------------------------------------------------------

	for(T=0; T<MAXFRAME; T++){ 
	
		px=90*(T-12*(T/12));  	py=400+90*(T/12); 	

		for(j=0;j<64;j++){ for(i=0;i<64;i++){ 

			c = Pth[i][j][T] * 800/max ; if(c>255)c=255; 

			SetColor(RGB(c,c,c));  SetPixel(i+px,j+py);
		}}
	}

	printf("\n Disp Projection Pth ");scanf("%c",&yn); 

//---------------------- Simple BackProjection --------------------------------------------

	for(j=0;j<64;j++){ for(i=0;i<64;i++){ SimpleBP[i][j] = 0; }}

	for(T=0;T<MAXFRAME;T++){ for(j=0;j<64;j++){ for(i=0;i<64;i++){ 
		
		SimpleBP[i][j] += Pth[i][j][T]; 
	}}}
	

//--------------------------- Disp Simple BackProjection ----------------------------------

	maxp=0;
	for(j=0;j<64;j++){ for(i=0;i<64;i++){ if(SimpleBP[i][j]>maxp)maxp=SimpleBP[i][j]; }}
	
	for(j=0;j<64;j++){ for(i=0;i<64;i++){ 	

		c = SimpleBP[i][j] * 255/maxp ;  if(c>255)c=255; 

		for(ii=0;ii<=3;ii++){ for(jj=0;jj<=3;jj++){
			
			SetColor(RGB(c,c,c));  SetPixel(4*i+ii+550,4*j+jj+140);
		}}
	}}

	printf("\n Change Reconstruction Slice ? \n (yes: enter, no: n) ");scanf("%c",&yn);
	if(yn!='n')goto SET_RECON_SLICE;

//------------------- End -------------------------------
	
	printf("\n\n Retry? (no:n) ");scanf("%c",&yn); if(yn!='n')goto START;
	exit(0);
}